package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.DivisionDAO;
import com.rjconsultores.ventaboletos.entidad.Division;
import com.rjconsultores.ventaboletos.service.DivisionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("divisionService")
public class DivisionServiceImpl implements DivisionService {

	@Autowired
	private DivisionDAO divisionDAO;

	@Override
	public List<Division> obtenerTodos() {
		return divisionDAO.obtenerTodos();
	}

	@Override
	public Division obtenerID(Integer id) {
		return divisionDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public Division suscribir(Division entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return divisionDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public Division actualizacion(Division entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return divisionDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(Division entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		divisionDAO.actualizacion(entidad);

	}

}
